/*
 * Created on Oct 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.util.*;
import edu.mit.six825.bn.functiontable.Function;
import edu.mit.six825.bn.functiontable.FunctionVariable;
import edu.mit.six825.bn.functiontable.FunctionVariableSet;
import edu.mit.six825.bn.bayesnet.*;
import edu.mit.six825.bn.functiontable.*;
import edu.mit.six825.bn.inputs.*;
import techniques.utils.Random;

/**
 * @author bushl2
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FactorSet extends Solver {

	public List nodes;
	public Vector initial_factors;
	public Vector factors;
	public Function evidence_factor;
	public Vector _elimination_order;
	public FunctionVariable factor_on_v;

	public boolean GreedyFlag;
	public int iterations;

	public FactorSet(BayesNet bn, Assignment evid) {
		super(bn);

		this.GreedyFlag = false;
		this.iterations = 1;

		this.setEvidence(evid);
		//this makes a copy of the nodes in a list
		nodes = bn.nodes.getNodesWithTopologicalOrdering();

		initial_factors = new Vector();
		for (Iterator i = nodes.iterator(); i.hasNext();) {
			BayesNetNode bnn = (BayesNetNode) i.next();
			initial_factors.add(bnn.cpt);
		}

		Output.out("The initial factors" + initial_factors);

		factors = new Vector();
		this.handle_the_evidence();

	}

	public void GreedyOrderTestSetup() {
		this.GreedyFlag = true;
		this.iterations = 1;
	}
	public void RandomOrderTestSetup() {
		this.GreedyFlag = false;
		this.iterations = 10;
	}
	public FunctionVariable GreedyOrder(Vector Order) {

		// Iterate over Order
		// Iterate over Factors

		// IF order variable is in the factor variable set 
		//  THEN Add the factor variables to the Order Set

		// How many variables are in the final set?
		// Elim the variable in Order, which generates the smallest variable set.
		int NumVars = 100000;
		FunctionVariable retElim_Next = new FunctionVariable("bogus");

		Iterator Oi = Order.iterator();
		while (Oi.hasNext()) { // over elim order
			FunctionVariable O_next = (FunctionVariable) Oi.next();

			Iterator Fi = this.factors.iterator();

			// Re-initialize the variable set:
			FunctionVariableSet O_var_set =
				new FunctionVariableSet(new FunctionVariable("bogus"));

			while (Fi.hasNext()) { // over elim order
				Function F_next = (Function) Fi.next();

				if (F_next.variables.size() > 0) {
					if (F_next.variables.contains(O_next)) {

						O_var_set =
							this.JoinFVSets(O_var_set, F_next.variables);
					}
				}
			}
			Output.outmin(
				"Number of vars in current greedy var set = " + NumVars);

			if (O_var_set.size() < NumVars) {
				retElim_Next = O_next;
				NumVars = O_var_set.size();
			}

		}
		NumVars = NumVars - 1;
		Output.outmin("Number of vars in best greedy var set = " + NumVars);
		return retElim_Next;

	}
	//public void FactorOn(BayesNetNode bnn,Assignment a,Vector eo) {
	public void FactorOn(FunctionVariable v) {
		
		long StartTime = java.util.Calendar.getInstance().getTimeInMillis();
		
		Output.out_query( v.toString(), this. _evidence.toString());
		this.factor_on_v = v;
		this.GenerateEliminationOrder();
		//this.GreedyOrder();

		Output.out2("Start Factoring");
		// Elimination order and Evidence are already stored in the class.
		//	handle_the_evidence();

		Output.outfactors("Starting factor set:" + factors);
		Output.outmin("Starting factor set size:" + factors.size());

		//_elimination_order.remove(v);

		Output.outmin(
			"----------------------------\n     Start Factor On\n----------------------------");
		Output.outmin(
			"Elimination Order: " + Output.out(this._elimination_order));
		// iterate over the variables in the elimination order:

		Iterator i = this._elimination_order.iterator();
		Vector temp_Order = new Vector(this._elimination_order);

		int count_eliminations = 1;
		while (i.hasNext()) { // over elim order

			FunctionVariable elim_next = (FunctionVariable) i.next();
			//String elim_next = (String) i.next();

			if (this.GreedyFlag) {
				elim_next = this.GreedyOrder(temp_Order);
			}

			Output.out_elim_var(elim_next.name);
			//outmin("temp_Order before "+temp_Order.toString());
			temp_Order.remove(elim_next);
			//outmin("temp_Order after removing "+elim_next+" : "+temp_Order.toString());

			//elim_next = (String) i.next();
			Output.outmin(
				"Eliminating Variable "
					+ count_eliminations++
					+ " of "
					+ this._elimination_order.size()
					+ " : "
					+ elim_next.name);

			Vector tableset = this.get_relevant_factors(elim_next);
			FunctionVariableSet joint_fv_set =
				this.get_tableset_variables(tableset.iterator());

			Output.outmin(
				"\nList of Variables Involved : " + joint_fv_set + "\n");
			//			

			Function add_back_in;

			if (elim_next.equals(v)) {
				add_back_in = factor_these(tableset, joint_fv_set);
				Output.outl("\n");
				Output.outl("Do not sum over " + v + ".");
			} else {
				add_back_in =
					sum_over(
						factor_these(tableset, joint_fv_set),
						joint_fv_set,
						new FunctionVariableSet(elim_next));
				Output.outl("\n");
				Output.outl("Sum over " + v + ".");
			}
			// Add it back in.
			Output.out2(
				"Generated a factor of size: "
					+ add_back_in.variables.cartesianProductSize());
			Output.out("The new Factor: (newf):" + add_back_in);
			Output.outfactors(
				"The new Factor Normalized: (newf):"
					+ Compute.normalize(add_back_in));
			//factors.add((add_back_in));
			factors.add(Compute.normalize(add_back_in));

			//_bn.nodes.getFunctionVariableSet().	
			//		out("New factor set:" + factors);
		} // END : over elim order

		//now elim Q:
		Vector tableset = this.get_all_factors();
		////		Vector tableset = this.get_relevant_factors(v);
		FunctionVariableSet joint_fv_set =
			this.get_tableset_variables(tableset.iterator());
		Function add_back_in = factor_these(tableset, joint_fv_set);
		factors.add(Compute.normalize(add_back_in));

		//		factors.add(
		//				Compute.normalize(
		//					factor_these(
		//						this.get_relevant_factors(v),
		//						this.get_tableset_variables(get_relevant_factors(v).iterator())
		//						)
		//					)
		//				);

		long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
		long RunTime = EndTime - StartTime;
		Output.out_timer(RunTime);
		Output.outmi("Final Factors:" + factors);
		Output.out(
			"----------------------------\n       End Factor On\n----------------------------");
	}

	public Vector get_relevant_factors(FunctionVariable elim_next) {

		//get all the factors that have the variable elim_next.

		// Instantiate the fvs:
		FunctionVariableSet joint_fv_set =
			new FunctionVariableSet(new FunctionVariable("bogus"));
		Vector tableset = new Vector();

		// go through each factor (ie, Earthquake, Burglary ...)
		// and make a list of the ones with Earthquake (the elim. var.) in them.
		Output.outl("\n");

		Output.outmin("Number of Factors: " + factors.size());
		for (Iterator fi = this.factors.iterator(); fi.hasNext();) {

			// 
			Function next_f = (Function) fi.next();

			if (next_f
				.variables //.contains(new FunctionVariable(elim_next))) {
				.contains(elim_next)) {

				tableset.add(next_f);
				fi.remove();

				joint_fv_set = JoinFVSets(joint_fv_set, next_f.variables);
			}
			// We now have tableset as the facters to combine.

		}
		joint_fv_set = joint_fv_set.subtract(new FunctionVariable("bogus"));

		return tableset;

	}
	public Vector get_all_factors() {

		//get all the factors that have the variable elim_next.

		// Instantiate the fvs:
		Vector tableset = new Vector();

		// go through each factor (ie, Earthquake, Burglary ...)
		Output.outl("\n");
		Output.out_join_vars("Number of Factors: " + factors.size());

		for (Iterator fi = this.factors.iterator(); fi.hasNext();) {
			Function next_f = (Function) fi.next();

			tableset.add(next_f);
			fi.remove();
			// We now have tableset as the facters to combine.
		}

		return tableset;

	}
	public FunctionVariableSet get_tableset_variables(Iterator tsi) {

		if (tsi.hasNext()) {
			return this.JoinFVSets(
				((Function) tsi.next()).variables,
				this.get_tableset_variables(tsi));
		} else {
			return null;
		}

	}
	public void handle_the_evidence() {
		Output.outmin("handle the evidence");

		// Here we create an evidence function.
		// It includes all evidence variables.
		evidence_factor =
			Compute.makeEvidenceFunction(
				this._evidence.variables,
				this._evidence);

		Output.outline();
		Output.out_evidence(
			"The Evidence Variables   :" + this._evidence.variables.toString());
		Output.out_evidence("The Evidence Assignments :" + this._evidence);
		Output.out_evidence(
			"The Evidence Factor      :" + this.evidence_factor);

		multiply_in_evidence();
	}

	public void multiply_in_evidence() {
		Output.outmin("Multily in evidence.");
		Function restricted_factor;
		Vector tableset = new Vector();

		//for each of the factors:
		for (Iterator fi = this.initial_factors.iterator(); fi.hasNext();) {
			Function next_f = (Function) fi.next();
			if (next_f
				.variables
				.containsAnyOf(this.evidence_factor.variables)) {

				//Reduce the evidence to just the common variables.
				FunctionVariableSet uncommon_evidence_variables =
					JoinFVSets(
						this.evidence_factor.variables,
						next_f.variables).subtract(
						next_f.variables);

				// Sum out the uncommon variables from the evidence.
				Function new_evidence_factor =
					sum_over(
						this.evidence_factor,
						this.evidence_factor.variables,
						uncommon_evidence_variables);

				// tableset should have the initial factor and the minimal evidence table
				tableset = new Vector();
				tableset.add(next_f);
				tableset.add(new_evidence_factor);

				//restricted_factor:
				// Factor on all the variables in the next factor and the new evidence.
				restricted_factor =
					factor_these(
						tableset,
						JoinFVSets(
							next_f.variables,
							new_evidence_factor.variables));

				// sum out the evidence variables:
				restricted_factor =
					sum_over(
						restricted_factor,
						restricted_factor.variables,
						new_evidence_factor.variables);

			} else {
				restricted_factor = next_f;
			}

			factors.add(restricted_factor);

		} // END : over elim order

		Output.outmi(
			"----------------------------\n       End Multiplying in Evidence.  \n----------------------------");
	}

	//	/////////////////////////////////////////////////////////////////////	
	//	/////////////////////////////////////////////////////////////////////	
	//	/////////////////////////////////////////////////////////////////////	

	public Function factor_these(Vector tableset, FunctionVariableSet fvs) {
		Output.outmin("factor_these");
		Output.outmin(
			"There are " + tableset.size() + " factors in the tableset.");
		//Function new_f = new Function();
		// for one assignment:
		double[] d = new double[fvs.cartesianProductSize()];
		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			d[dcount] = 1;
			Assignment a = (Assignment) fvsi.next();

			//out("Computed position: " + a.computePosition());
			for (Iterator ti = tableset.iterator(); ti.hasNext();) {
				Function tempf = (Function) ti.next();

				// This is where the factors are multiplied:
				//	out("Tableset:" + tableset);
				d[dcount] = d[dcount] * tempf.evaluate(a);
			}
			dcount++;

		}

		Function newf = new Function(fvs, d);
		//		out("the fvs: " + fvs);
		Output.outl("The new Factor: (newf):" + newf);
		Output.outl(
			"The new Factor Normalized: (newf):" + Compute.normalize(newf));
		//	return Compute.normalize(newf);
		return (newf);
	}

	public Function sum_over(
		Function f,
		FunctionVariableSet fvs,
		FunctionVariableSet s) {

		Output.outmin("sum_over");

		FunctionVariableSet fvs_less_s = fvs.subtract((s));

		// for one assignment:
		double[] d = new double[fvs_less_s.cartesianProductSize()];

		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			Assignment a = (Assignment) fvsi.next();

			d[a.computePosition(fvs_less_s)] =
				d[a.computePosition(fvs_less_s)] + f.evaluate(a);

		}
		Function newf = new Function(fvs_less_s, d);

		return newf;

	}

	public FunctionVariableSet JoinFVSets(
		FunctionVariableSet current_fvs,
		FunctionVariableSet fvs) {
		FunctionVariableSet return_fvs;

		if ((fvs == null) & (current_fvs == null)) {

			return_fvs = null;

		} else if (fvs == null) {

			return_fvs = current_fvs;

		} else if (current_fvs == null) {

			return_fvs = fvs;

		} else if (fvs.size() == 0) {

			return_fvs = current_fvs;

		} else if (current_fvs.size() == 0) {

			return_fvs = fvs;

		} else {

			Output.out_join_vars("Size of fvs : " + fvs.size());
			Output.out_join_vars("Size of fvs_current : " + current_fvs.size());
			Output.out_join_vars(current_fvs.toString());
			return_fvs = FunctionVariableSet.union(current_fvs, fvs);

		}

		return return_fvs;

	}

	public void Remove(String nodename) {

		//nodes.
		//		out(_bn.nodes.toString());
		//		BayesNetNode temp_bnn = _bn.nodes.getNode(v2e.name);
		//		Iterator i = _bn.nodes.getNodesWithTopologicalOrdering().iterator();
		//		i.next();
		//		i.remove();
		//		out(_bn.nodes.toString());

	}
	
	public void SetupQuery(BayesNet bn, Vector variables, Vector values) {
		
		




}	
	
	public Function query(BayesNetNode variable) {
	//return enumerationAsk(variable);
	return variable.cpt;
	//		return bn.nodes.getNode(1);
}
	public Vector GenerateEliminationOrder() {
		Output.outmin("GenerateEliminationOrder");
		Vector elimination_order = new Vector();
		//	this._bn.nodes.getNodesWithTopologicalOrdering();

		List nodes_copy = nodes;
		while (nodes_copy.size() > 0) {

			int get_node_index = Random.random(nodes_copy.size());
			BayesNetNode bnn = (BayesNetNode) nodes.get(get_node_index);
			nodes_copy.remove(get_node_index);

			if (!this.evidence_factor.variables.contains(bnn.var)) {
				//Don't include E.
				if (!this.factor_on_v.equals(bnn.var)) { //Don't include Q.
					elimination_order.add(bnn.var);
				}
			}
		}

		//elimination_order.remove(this.factor_on_v);
		//	elimination_order.add(this.factor_on_v);
		//	elimination_order.insertElementAt(this.factor_on_v, 0);

		//	for(Iterator vfvi = this._evidence)
		elimination_order.remove(this.evidence_factor.variables);
		this._elimination_order = elimination_order;
		Output.outmin("Elim Order=" + elimination_order.toString());
		return elimination_order;
	}

	public static void main(String[] args) {

		BayesNet BurglaryInstance = Nets.getBurglary();
		 

		final FunctionVariable[] vars = new FunctionVariable[2];
		vars[0] = new FunctionVariable("JohnCalls");
		vars[1] = new FunctionVariable("MaryCalls");
		final Comparable[] vals = new Comparable[2];
		vals[0] = ComparableBoolean.TRUE;
		vals[1] = ComparableBoolean.TRUE;
		final Assignment evidence =
			new Assignment(new FunctionVariableSet(vars), vals);

		FactorSet bgfs = new FactorSet(BurglaryInstance, evidence);
		//	FactorSet bgfs = new FactorSet(BurglaryInstance);
		//	bgfs.setEvidence(evidence);

		Output.ShowFactorSetNames(bgfs.factors);

		//Output.outl(Output.out(bgfs.GenerateEliminationOrder()));

		bgfs.FactorOn(new FunctionVariable("Burglary"));

		//		bgfs.handle_the_evidence();

		Output.out("\nNew Factors: " + bgfs.factors.toString());

		//	
		//	
		//	///////////////////////////////////////////////////////
		//	/////////       Insurance                    //////////
		//	///////////////////////////////////////////////////////

		BayesNet Insurance1 = Nets.getInsurance();

		List nodes = Insurance1.nodes.getNodesWithTopologicalOrdering();

		Domain AgeDomain = new Domain(vals);
		Domain AntilockDomain = new Domain(vals);
		Domain MileageDomain = new Domain(vals);
		FunctionVariable PropCostVar = new FunctionVariable("PropCost");

		for (Iterator i = nodes.iterator(); i.hasNext();) {
			BayesNetNode bnn = (BayesNetNode) i.next();
			if (bnn.var.name.compareTo("Age") == 0)
				AgeDomain = bnn.var.domain;
			if (bnn.var.name.compareTo("Antilock") == 0)
				AntilockDomain = bnn.var.domain;
			if (bnn.var.name.compareTo("Mileage") == 0)
				MileageDomain = bnn.var.domain;
			if (bnn.var.name.compareTo("PropCost") == 0)
				PropCostVar = bnn.var;

		}

		final FunctionVariable[] Insurance1vars = new FunctionVariable[3];
		Insurance1vars[0] = new FunctionVariable("Age", AgeDomain);
		Insurance1vars[1] = new FunctionVariable("Antilock", AntilockDomain);
		System.out.println("AntilockDomain" + AntilockDomain);
		Insurance1vars[2] = new FunctionVariable("Mileage", MileageDomain);
		final Comparable[] Insurance1vals = new Comparable[3];
		Insurance1vals[0] = "Adolescent";
		Insurance1vals[1] = "False";
		Insurance1vals[2] = "FiftyThou";
		final Assignment Insurance1evidence =
			new Assignment(
				new FunctionVariableSet(Insurance1vars),
				Insurance1vals);


		FactorSet Insurance1fs = new FactorSet(Insurance1, Insurance1evidence);
		//	FactorSet Insurance1fs = new FactorSet(Insurance1);

		//	Vector Insurance1eo = Insurance1fs.GenerateEliminationOrder();

		Insurance1fs.GreedyOrderTestSetup();
		Insurance1fs.FactorOn(PropCostVar);

	}
}
