/*
 * Created on Oct 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.util.*;
import java.math.*;

//import com.sun.rsasign.n;

import edu.mit.six825.bn.functiontable.Function;
import edu.mit.six825.bn.functiontable.FunctionVariable;
import edu.mit.six825.bn.functiontable.FunctionVariableSet;
import edu.mit.six825.bn.bayesnet.*;
import edu.mit.six825.bn.functiontable.*;
import edu.mit.six825.bn.inputs.*;
import techniques.utils.Random;

/**
 * @author bushl2
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FactorSet extends Solver {

	public List nodes;
	public Vector initial_factors;
	public Vector factors;
	public Function evidence_factor;
	public Vector _elimination_order;
	public FunctionVariable factor_on_v;

	public boolean GreedyFlag;
	public boolean GreedyMultFlag;
	public boolean GreedyTiesFlag;
	public int iterations;
	public long RunTime;
	public long number_of_multiplications;
	
	public FactorSet(BayesNet bn, Vector Variables, Vector Values) {
		super(bn);

		this.GreedyFlag = false;
		this.GreedyMultFlag = false;
		this.GreedyTiesFlag = false;
		
		this.iterations = 1;

		this.setEvidence(SetupQuery(bn, Variables, Values));
		//this makes a copy of the nodes in a list
		nodes = bn.nodes.getNodesWithTopologicalOrdering();

		initial_factors = new Vector();
		for (Iterator i = nodes.iterator(); i.hasNext();) {
			BayesNetNode bnn = (BayesNetNode) i.next();
			initial_factors.add(bnn.cpt);
		}

		Output.out("The initial factors" + initial_factors);

		factors = new Vector();
		this.handle_the_evidence();

	}

	public BayesNet get_bn() {

		return _bn;

	}
	public Assignment get_evidence() {

		return this._evidence;

	}

	public void GreedyOrderTestSetup() {
		this.GreedyFlag = true;
		this.iterations = 1;
	}
	public void GreedyMultOrderTestSetup() {
		this.GreedyFlag = true;
		this.GreedyMultFlag = true;
		this.iterations = 1;
	}
	
	public void GreedyTiesOrderTestSetup() {
		this.GreedyFlag = true;
		this.GreedyMultFlag = true;
		this.iterations = 1;
		this.GreedyTiesFlag = true;
	}
	
	public void RandomOrderTestSetup() {
		this.GreedyFlag = false;
		this.iterations = 1;
	}

	public FunctionVariable GreedyOrder(Vector Order) {

		// Iterate over Order
		// Iterate over Factors

		// IF order variable is in the factor variable set 
		//  THEN Add the factor variables to the Order Set

		// How many variables are in the final set?
		// Elim the variable in Order, which generates the smallest variable set.
		int cpsize = 2000000000;
		int num_vars = 0;
		FunctionVariable retElim_Next = new FunctionVariable("bogus");

		Iterator Oi = Order.iterator();
		while (Oi.hasNext()) { // over elim order
			FunctionVariable O_next = (FunctionVariable) Oi.next();

			Iterator Fi = this.factors.iterator();

			// Re-initialize the variable set:
			FunctionVariableSet O_var_set = new FunctionVariableSet(O_next);

			while (Fi.hasNext()) { // over elim order
				Function F_next = (Function) Fi.next();

				if (F_next.variables.size() > 0) {
					if (F_next.variables.contains(O_next)) {

						O_var_set =
							this.JoinFVSets(O_var_set, F_next.variables);
					}
				}
			}
			
			 
			if (O_var_set.cartesianProductSize() < cpsize) {
				retElim_Next = O_next;
				cpsize = O_var_set.cartesianProductSize();
				num_vars = O_var_set.size();
			}

		}
		Output.outmin("Number of vars in best greedy var set = " + cpsize);
		
		//number_of_multiplications = number_of_multiplications + cpsize*num_vars;
		return retElim_Next;

	}

	public FunctionVariable GreedyOrderTies(Vector Order) {

		// Iterate over Order
		// Iterate over Factors

		// IF order variable is in the factor variable set 
		//  THEN Add the factor variables to the Order Set

		// How many variables are in the final set?
		// Elim the variable in Order, which generates the smallest variable set.
		int cpsize = 2000000000;
		int num_mults = 2000000000;
		int num_vars = 0;
		FunctionVariable retElim_Next = new FunctionVariable("bogus");

		Iterator Oi = Order.iterator();
		while (Oi.hasNext()) { // over elim order
			FunctionVariable O_next = (FunctionVariable) Oi.next();

			Iterator Fi = this.factors.iterator();

			// Re-initialize the variable set:
			FunctionVariableSet O_var_set = new FunctionVariableSet(O_next);

			while (Fi.hasNext()) { // over elim order
				Function F_next = (Function) Fi.next();

				if (F_next.variables.size() > 0) {
					if (F_next.variables.contains(O_next)) {

						O_var_set =
							this.JoinFVSets(O_var_set, F_next.variables);
					}
				}
			}
			
			 
			if (O_var_set.cartesianProductSize() <= cpsize) {
				if(O_var_set.cartesianProductSize() == cpsize){
					
					if (O_var_set.cartesianProductSize()*O_var_set.size() < num_mults) {
						retElim_Next = O_next;
						cpsize = O_var_set.cartesianProductSize();
						num_vars = O_var_set.size();
						num_mults = cpsize*num_vars;
					}
					
				} else {
				
				retElim_Next = O_next;
				cpsize = O_var_set.cartesianProductSize();
				num_vars = O_var_set.size();
				num_mults = cpsize*num_vars;
				
				}
			}

		}
		Output.outmin("Number of vars in best greedy var set = " + cpsize);
		
		//number_of_multiplications = number_of_multiplications + cpsize*num_vars;
		return retElim_Next;

	}

	public FunctionVariable GreedyOrderMults(Vector Order) {
		
if(this.GreedyTiesFlag){
	return this.GreedyOrderTies(Order);
}
			// Iterate over Order
			// Iterate over Factors

			// IF order variable is in the factor variable set 
			//  THEN Add the factor variables to the Order Set

			// How many variables are in the final set?
			// Elim the variable in Order, which generates the smallest variable set.
		int cpsize = 2000000000;
		int num_mults = 2000000000;
			int num_vars = 0;
			FunctionVariable retElim_Next = new FunctionVariable("bogus");

			Iterator Oi = Order.iterator();
			while (Oi.hasNext()) { // over elim order
				FunctionVariable O_next = (FunctionVariable) Oi.next();

				Iterator Fi = this.factors.iterator();

				// Re-initialize the variable set:
				FunctionVariableSet O_var_set = new FunctionVariableSet(O_next);

				while (Fi.hasNext()) { // over elim order
					Function F_next = (Function) Fi.next();

					if (F_next.variables.size() > 0) {
						if (F_next.variables.contains(O_next)) {

							O_var_set =
								this.JoinFVSets(O_var_set, F_next.variables);
						}
					}
				}
			
			 
				if (O_var_set.cartesianProductSize()*O_var_set.size() < num_mults) {
					retElim_Next = O_next;
					cpsize = O_var_set.cartesianProductSize();
					num_vars = O_var_set.size();
					num_mults = cpsize*num_vars;
				}

			}
			Output.outmin("Number of vars in best greedy var set = " + cpsize);
		
			//number_of_multiplications = number_of_multiplications + cpsize*num_vars;
			return retElim_Next;

		}



	public FunctionVariable GreedyOrderVariableOnly(Vector Order) {

		// Iterate over Order
		// Iterate over Factors

		// IF order variable is in the factor variable set 
		//  THEN Add the factor variables to the Order Set

		// How many variables are in the final set?
		// Elim the variable in Order, which generates the smallest variable set.
		int cpsize = 1000000000;
		FunctionVariable retElim_Next = new FunctionVariable("bogus");

		Iterator Oi = Order.iterator();
		while (Oi.hasNext()) { // over elim order
			FunctionVariable O_next = (FunctionVariable) Oi.next();

			Iterator Fi = this.factors.iterator();

			// Re-initialize the variable set:
			FunctionVariableSet O_var_set = new FunctionVariableSet(O_next);

			while (Fi.hasNext()) { // over elim order
				Function F_next = (Function) Fi.next();

				if (F_next.variables.size() > 0) {
					if (F_next.variables.contains(O_next)) {

						O_var_set =
							this.JoinFVSets(O_var_set, F_next.variables);
					}
				}
			}
			Output.outmin(
				"Number of vars in current greedy var set = " + cpsize);

			if (O_var_set.cartesianProductSize() < cpsize) {
				retElim_Next = O_next;
				cpsize = O_var_set.cartesianProductSize();
			}

		}
		Output.outmin("Number of vars in best greedy var set = " + cpsize);
		return retElim_Next;

	}

	public void LikelihoodOn(String sv) {
		RunTime = 999999999;
		long StartTime = java.util.Calendar.getInstance().getTimeInMillis();

		List elim_order = this._bn.nodes.getNodesWithTopologicalOrdering();
		Assignment current_assignment = this._evidence;
		Vector possible_assignments = new Vector();
		FunctionVariable sampled_variable = MakeFunctionVariable(sv);
		HashMap count = new HashMap();
		for (Iterator svi = sampled_variable.domain.iterator();
			svi.hasNext();
			count.put(
				sampled_variable.domain.getValue((DomainIndex) svi.next()),
				new Double(0)));
		int S = 100000;
		for (int number_of_samples = 0;
			number_of_samples < S;
			number_of_samples++) {

			// for each sample:
			double w = 1;

			//	Set all non-evidence nodes in topo-order.
			for (Iterator eoi = elim_order.iterator(); eoi.hasNext();) {

				BayesNetNode next_node = (BayesNetNode) eoi.next();
				FunctionVariable next_variable = next_node.var;
				Domain dom = next_variable.domain;

				if (this._evidence.contains(next_variable)) {
					// Evidence: do the weighting, and don't sample this variable
					w = w * next_node.cpt.evaluate(current_assignment);

					//					System.out.println(
					//						"P("
					//							+ next_node.var
					//							+ "|"
					//							+ next_node.parents
					//							+ ") = "
					//							+ next_node.cpt.evaluate(current_assignment));

				} else {
					// Non-Evidence: sample this variable

					// Create the possible assignments (over the domain of the current variable).
					possible_assignments = new Vector(); //reset
					for (Iterator di = dom.iterator(); di.hasNext();) {

						possible_assignments.add(
							new Assignment(
								(Assignment) current_assignment,
								next_variable,
								dom.getValue((DomainIndex) di.next())));
					}

					// generate the probabilities from the current variable.
					double[] d =
						make_prob(
							next_node.cpt,
							new FunctionVariableSet(next_node.var),
							possible_assignments);
					int rand_val = Random.samplePartialProbDist(d);
					Comparable temp_value =
						(Comparable) next_variable.domain.getValue(rand_val);
					// add it to the current assignment
					current_assignment =
						new Assignment(
							current_assignment,
							next_variable,
							temp_value);
					//					System.out.println(
					//						"Current Assignment" + current_assignment);
				}
			}
			//			System.out.println(
			//				"Current Assignment" + current_assignment);
			Object assigned_sample_value =
				current_assignment.getAssignedValue(sampled_variable);

			double updated_count =
				((Double) count.get(assigned_sample_value)).doubleValue() + w;
			count.put(assigned_sample_value, new Double(updated_count));
			//			System.out.println(count);

			if ((number_of_samples % 5000) == 0) {
				//HashMap temphm = new HashMap();
				double sum = 0;
				double temp = 0;

				for (Iterator svi = sampled_variable.domain.iterator();
					svi.hasNext();
					sum =
						sum
							+ ((Double) count
								.get(
									sampled_variable.domain.getValue(
										(DomainIndex) svi.next())))
								.doubleValue());

				for (Iterator svi = sampled_variable.domain.iterator();
					svi.hasNext();
					) {

					Comparable domain_value =
						sampled_variable.domain.getValue(
							(DomainIndex) svi.next());

					temp =
						((Double) count.get(domain_value)).doubleValue() / sum;

					//		temphm.put(domain_value, new Double(temp));

				}
				long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
				RunTime = EndTime - StartTime;
				System.out.println(
					"P("
						+ sampled_variable.toString()
						+ "|"
						+ this._evidence.variables
						+ ") = "
						+ temp
						+ "  ("
						+ number_of_samples
						+ " of "
						+ S
						+ " samples)  "+"Runtime= "+RunTime);
				//				System.out.println(temp/sum);

			}
			long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
			RunTime = EndTime - StartTime;
		}

		double sum = 0;
		for (Iterator svi = sampled_variable.domain.iterator();
			svi.hasNext();
			sum =
				sum
					+ ((Double) count
						.get(
							sampled_variable.domain.getValue(
								(DomainIndex) svi.next())))
						.doubleValue());

		for (Iterator svi = sampled_variable.domain.iterator();
			svi.hasNext();
			) {

			Comparable domain_value =
				sampled_variable.domain.getValue((DomainIndex) svi.next());

			double temp =
				((Double) count.get(domain_value)).doubleValue() / sum;

			count.put(domain_value, new Double(temp));

		}

		System.out.println(count);
	}

	public Assignment initialize_gibbs_assignment(Assignment current_assignment) {

		//initialize_gibss_assigment
		Assignment temp_assignment =
			(Assignment) this
				._bn
				.nodes
				.getFunctionVariableSet()
				.assignmentIterator()
				.next();
		// then make set the evidence to jive with this.

		List elim_order = this._bn.nodes.getNodesWithTopologicalOrdering();
		for (Iterator cai = elim_order.iterator(); cai.hasNext();) {

			BayesNetNode next_cai_node = (BayesNetNode) cai.next();
			FunctionVariable next_cai_variable = next_cai_node.var;

			if (current_assignment.contains(next_cai_variable)) {
				temp_assignment =
					new Assignment(
						temp_assignment,
						next_cai_variable,
						current_assignment.getAssignedValue(next_cai_variable));

			}
		}
		return temp_assignment;
	}

	public String GibbsOn(String sv, int number_of_sampling_rounds, int number_of_burnin_rounds ) {

		System.out.println("Gibbs Sampler");
		RunTime = 999999999;
		long StartTime = java.util.Calendar.getInstance().getTimeInMillis();

		List elim_order = this._bn.nodes.getNodesWithTopologicalOrdering();
		Assignment current_assignment = this._evidence;
		Vector possible_assignments = new Vector();
		FunctionVariable sampled_variable = MakeFunctionVariable(sv);

		//initialize_gibbs_assigment
		current_assignment = initialize_gibbs_assignment(current_assignment);
		System.out.println("current_assignment" + current_assignment);

		////////////////////////////////////
		//Initialize the counters:
		// A variable map of domain maps:
		//
		HashMap variable_counts = new HashMap();
		HashMap value_counts = new HashMap();

		for (Iterator all_vars_i = elim_order.iterator();
			all_vars_i.hasNext();
			) {

			FunctionVariable next_variable =
				((BayesNetNode) all_vars_i.next()).var;

			value_counts = new HashMap();
			for (Iterator nvi = next_variable.domain.iterator();
				nvi.hasNext();
				value_counts.put(
					next_variable.domain.getValue((DomainIndex) nvi.next()),
					new Double(0)));

			variable_counts.put(next_variable, value_counts);
		}
		System.out.println("Initial Count TableTable " + variable_counts);
		//end counter init.
		////////////////////////////////////


		int N_size = elim_order.size();

		for (int sample_round = 0;
		sample_round < number_of_sampling_rounds;
		sample_round++) {

			if (sample_round >= number_of_burnin_rounds) {
				// track sample counts

	
				//Add to the counters:
				// A variable map of domain maps:
				//HashMap value_counts = new HashMap();
				for (Iterator all_vars_i = elim_order.iterator();
					all_vars_i.hasNext();
					) {

					FunctionVariable next_variable_to_count =
						((BayesNetNode) all_vars_i.next()).var;

					HashMap updatable_value_counts_for_this_var_hm =
						((HashMap) variable_counts.get(next_variable_to_count));

					Comparable temp_assigned_sample_value =
						current_assignment.getAssignedValue(
							next_variable_to_count);

					double updatable_counter_for_this_vars_val =
						((Double) updatable_value_counts_for_this_var_hm
							.get(temp_assigned_sample_value))
							.doubleValue()
							+ 1;

					// put it back in:
					updatable_value_counts_for_this_var_hm.put(
						temp_assigned_sample_value,
						new Double(updatable_counter_for_this_vars_val));

					variable_counts.put(
						next_variable_to_count,
						updatable_value_counts_for_this_var_hm);

				}
///////  end add to counts
//				System.out.println(
//					"New Count TableTable     " + variable_counts);

//				if (number_of_samples == 5)
//					pause("----------------------------------\npause after new count table \n----------------------------");
			}

			// for each sample:

			//	Sample all non-evidence nodes.
			//  Is there a preferred order (i.e. random)
			for (Iterator eoi = elim_order.iterator(); eoi.hasNext();) {

				BayesNetNode next_node = (BayesNetNode) eoi.next();
				FunctionVariable next_variable = next_node.var;
				Domain dom = next_variable.domain;

				//				Output.outline2();

				//				System.out.print(
				//					"S = "
				//						+ number_of_samples
				//						+ ", Next Var ="
				//						+ next_variable
				//						+ " : ");

				if (this._evidence.contains(next_variable)) {

					////////////////////////////////////////////////////////////////////////////////////		
					//					System.out.println(" - An Evidence Var");
					//					Output.outline2();
					////////////////////////////////////////////////////////////////////////////////////		

					// Evidence: do the weighting, and don't sample this variable
					//	w = w * next_node.cpt.evaluate(current_assignment);

					//					System.out.println(
					//						"P("
					//							+ next_node.var
					//							+ "|"
					//							+ next_node.parents
					//							+ ") = "
					//							+ next_node.cpt.evaluate(current_assignment));

				} else {
					// Non-Evidence: sample this variable
					//					System.out.println("A NON - Evidence Var");
					//					Output.outline2();

					// Create the possible assignments (over the domain of the current variable).
					possible_assignments = new Vector(); //reset
					for (Iterator di = dom.iterator(); di.hasNext();) {

						possible_assignments.add(
							new Assignment(
								(Assignment) current_assignment,
								next_variable,
								dom.getValue((DomainIndex) di.next())));
					} // now there are 2 possible assignments (or more) for this next variable
					// we calc. the prob of each given markov blanket, then choose 1 given the distribution.

					// generate the probabilities from the current variable.

					// me given my parents
					double[] d =
						make_prob(
							next_node.cpt,
							new FunctionVariableSet(next_node.var),
							possible_assignments);
					// my children, given their parents
					// loop through all
					// see if I am their parents
					// if so, calculate their prob of current state (x' assuming the possible evidence)

					////////////////////////////////////////////////////////////////////////////
					//					int pan_index = 0;
					//					for (Iterator pa_itr = possible_assignments.iterator();
					//						pa_itr.hasNext();
					//						pan_index++) {
					//						Assignment pan = (Assignment) pa_itr.next();
					//						System.out.println(
					//							"P("
					//								+ next_node.toString()
					//								+ "|"
					//								+ pan.toString()
					//								+ ") = "
					//								+ d[pan_index]);
					//					}
					//					Output.outline2();
					/////////////////////////////////////////////////////////////////////

					for (Iterator find_my_children = elim_order.iterator();
						find_my_children.hasNext();
						) {

						BayesNetNode next_child_node =
							(BayesNetNode) find_my_children.next();
						FunctionVariable next_child_variable =
							next_child_node.var;
						Domain child_dom = next_child_variable.domain;

						if (next_child_node
							.cpt
							.variables
							.contains(next_variable)
							& (next_child_node != next_node)) {
							// calculate P( child = current state | child.parents current state )
							double[] c =
								make_prob(
									next_child_node.cpt,
									new FunctionVariableSet(
										next_child_node.var),
									possible_assignments);

							// multiply c * d

							// debug code ////////////
							//							System.out.println(
							//								"Child node: "
							//									+ next_child_node.toString()
							//									+ " of "
							//									+ next_node.toString());

							////////////////////////////////////////////////////////////////////////////////////		
							//							pan_index = 0;
							//							for (Iterator pa_itr =
							//								possible_assignments.iterator();
							//								pa_itr.hasNext();
							//								pan_index++) {
							//								Assignment pan = (Assignment) pa_itr.next();
							//								System.out.println(
							//									"P("
							//										+ next_child_node.toString()
							//										+ "|"
							//										+ pan.toString()
							//										+ ") = "
							//										+ c[pan_index]);
							//							}
							////////////////////////////////////////////////////////////////////////////////////		
// debug zero probs
//							Output.outline2();
//							Output.outline2();
//							Output.outline2();
//							  System.out.println("P("+next_child_node.toString()+"|"+next_child_node.parents.toString()+") = "+c[0]+", "+c[1]);

							// end debug code //////////

							d = dot_mult(d, c, possible_assignments.size());
							
							
							
//							for (int d_count = 0;
//								d_count < possible_assignments.size();
//								d_count++) {
////								System.out.println(
////									"P("
////										+ next_child_node.toString()
////										+ "|"
////										+ next_node.parents.toString()
////										+ ") = "
////										+ c[0]
////										+ ", "
////										+ c[1]);
//
//								System.out.println(
//									"Child * prev. node = "
//										+ d_count
//										+ "  :  "
//										+ d[d_count]);
//							}
//							Output.outline2();
//							System.out.println(this._bn.nodes.getNode(next_child_node.toString()));
//							System.out.println(this._bn.nodes.getNode(next_child_node.toString()).cpt);
//							for(Iterator paid = possible_assignments.iterator();paid.hasNext();System.out.println("Possible Assignments:"+paid.next()));
					
						}

					}

					int rand_val = Random.samplePartialProbDist(d);
//					System.out.println("Random Value = "+rand_val);
//					Output.outline2();
					
					Comparable temp_value =
						(Comparable) next_variable.domain.getValue(rand_val);
					// add it to the current assignment
					current_assignment =
						new Assignment(
							current_assignment,
							next_variable,
							temp_value);

					////////////////////////////////////////////////////////////////////////////////////		
					//					System.out.println(
					//						"Generate Rand Value for "
					//							+ next_variable.toString()
					//							+ ", = "
					//							+ temp_value.toString());
					//					System.out.println(
					//						"New Current Assignment" + current_assignment);
					//					Output.outline2();
					////////////////////////////////////////////////////////////////////////////////////		

				}
			}
//			System.out.println(
//				"Current Assignment after sampling all variables: "
//					+ current_assignment);

			Object assigned_sample_value =
				current_assignment.getAssignedValue(sampled_variable);

			//	pause("pause1");

			//			System.out.println(count);

			//			if ((number_of_samples % 2) == 0) {
			//				//HashMap temphm = new HashMap();
			//				System.out.println("Stats: ");
			//				double sum = 0;
			//				double temp = 0;
			//
			//				for (Iterator svi = sampled_variable.domain.iterator();
			//					svi.hasNext();
			//					sum =
			//						sum
			//							+ ((Double) count
			//								.get(
			//									sampled_variable.domain.getValue(
			//										(DomainIndex) svi.next())))
			//								.doubleValue());
			//
			//				for (Iterator svi = sampled_variable.domain.iterator();
			//					svi.hasNext();
			//					) {
			//
			//					Comparable domain_value =
			//						sampled_variable.domain.getValue(
			//							(DomainIndex) svi.next());
			//
			//					temp =
			//						((Double) count.get(domain_value)).doubleValue() / sum;
			//
			//					//		temphm.put(domain_value, new Double(temp));
			//
			//				}
			//
			//				System.out.println(
			//					"P("
			//						+ sampled_variable.toString()
			//						+ "|"
			//						+ this._evidence.variables
			//						+ ") = "
			//						+ temp
			//						+ "  ("
			//						+ number_of_samples
			//						+ " of "
			//						+ S
			//						+ " samples)");
			//				//				System.out.println(temp/sum);
			//
			//			}

			if ((sample_round % 50) == 0) {
			
	
			long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
			RunTime = EndTime - StartTime;	
			System.out.println("sample_round= "+sample_round+"  RunTime= "+RunTime);
			}
		}

		// Final Re-normalization of counts:
		//		double sum = 0;
		//		for (Iterator svi = sampled_variable.domain.iterator();
		//			svi.hasNext();
		//			sum =
		//				sum
		//					+ ((Double) count
		//						.get(
		//							sampled_variable.domain.getValue(
		//								(DomainIndex) svi.next())))
		//						.doubleValue());
		//
		//		for (Iterator svi = sampled_variable.domain.iterator();
		//			svi.hasNext();
		//			) {
		//
		//			Comparable domain_value =
		//				sampled_variable.domain.getValue((DomainIndex) svi.next());
		//
		//			double temp =
		//				((Double) count.get(domain_value)).doubleValue() / sum;
		//
		//			count.put(domain_value, new Double(temp));
		//
		//		}

		System.out.println(variable_counts);

			  /////////////////////////	
			  //  Final Normalization
			  /////////////////////////
			  
			  // A variable map of domain maps:
			  //HashMap value_counts = new HashMap();
			  for (Iterator all_vars_i = elim_order.iterator();
				  all_vars_i.hasNext();
				  ) {

				  FunctionVariable next_variable_to_count =
					  ((BayesNetNode) all_vars_i.next()).var;

					for (Iterator nvtcdi = next_variable_to_count.domain.iterator();
					nvtcdi.hasNext();){
					

Comparable temp_assigned_sample_value =
	(Comparable) next_variable_to_count.domain.getValue(
		(DomainIndex) nvtcdi.next());	

					//current_assignment.getAssignedValue(
					//	next_variable_to_count);

				  HashMap updatable_value_counts_for_this_var_hm =
					  ((HashMap) variable_counts.get(next_variable_to_count));

				  

				  double updatable_counter_for_this_vars_val =
					  ((Double) updatable_value_counts_for_this_var_hm
						  .get(temp_assigned_sample_value))
						  .doubleValue()
						  / (number_of_sampling_rounds - number_of_burnin_rounds);

				  // put it back in:
				  updatable_value_counts_for_this_var_hm.put(
					  temp_assigned_sample_value,
					  new Double(updatable_counter_for_this_vars_val));

				  variable_counts.put(
					  next_variable_to_count,
					  updatable_value_counts_for_this_var_hm);
					}
			  }
///////  end add to counts
			  System.out.println(
				  "Final Count TableTable     " + variable_counts);
		System.out.println(
			"\nQuery Result:   P(" + sv + "|"+this._evidence+") = "+variable_counts.get(sampled_variable));
			
			String ret_val=new String("");
		for (Iterator nvtcdi = sampled_variable.domain.iterator();
							
							nvtcdi.hasNext();){
								
//								Comparable temp_assigned_sample_value =
//									(Comparable) ((FunctionVariable)variable_counts.get(sampled_variable)).domain.getValue(
//										(DomainIndex) nvtcdi.next());
								
								Comparable temp_assigned_sample_value =
									(Comparable) sampled_variable.domain.getValue(
										(DomainIndex) nvtcdi.next());	
										
								HashMap updatable_value_counts_for_this_var_hm =
									((HashMap) variable_counts.get(sampled_variable));

				  			
													
								double updatable_counter_for_this_vars_val =
									((Double) updatable_value_counts_for_this_var_hm
										.get(temp_assigned_sample_value))
										.doubleValue();			
							
							ret_val = ret_val+"   "+updatable_counter_for_this_vars_val;
							}
		System.out.println(ret_val);
							
		long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
		RunTime = EndTime - StartTime;					
			return ret_val;


	}

	public double[] dot_mult(double[] a, double[] b, int size) {
		//System.out.println("Enter dot mult");
		double[] ab = new double[size];
		for (int count = 0; count < size; count++) {

			ab[count] = a[count] * b[count];

		}
		//		System.out.println("Exit dot mult");
		return ab;
	}

	public void pause(String sv) {
		System.out.println(sv);
		while (true) {
		}
	}

	public void FactorOn(String sv) {


		this.number_of_multiplications = 0;
		
		FunctionVariable v = MakeFunctionVariable(sv);
		RunTime = 999999999;
		long StartTime = java.util.Calendar.getInstance().getTimeInMillis();

		Output.out_query(v.toString(), this._evidence.toString());
		this.factor_on_v = v;
		this.GenerateEliminationOrder();
		//this.GreedyOrder();

		Output.out2("Start Factoring");
		// Elimination order and Evidence are already stored in the class.
		//	handle_the_evidence();

		Output.outfactors("Starting factor set:" + factors);
		Output.outmin("Starting factor set size:" + factors.size());

		//_elimination_order.remove(v);

		Output.outmin(
			"----------------------------\n     Start Factor On\n----------------------------");
		Output.outmin(
			"Elimination Order: " + Output.out(this._elimination_order));
		// iterate over the variables in the elimination order:

		Iterator i = this._elimination_order.iterator();
		Vector temp_Order = new Vector(this._elimination_order);

		int count_eliminations = 1;
		while (i.hasNext()) { // over elim order

			FunctionVariable elim_next = (FunctionVariable) i.next();
			//String elim_next = (String) i.next();

			if (this.GreedyFlag) {
				
				if (this.GreedyMultFlag) {

					elim_next = this.GreedyOrderMults(temp_Order);
				} else {
				
				elim_next = this.GreedyOrder(temp_Order);
				}
			
			}

			Output.out_elim_var(elim_next.name);
			//outmin("temp_Order before "+temp_Order.toString());
			temp_Order.remove(elim_next);
			//outmin("temp_Order after removing "+elim_next+" : "+temp_Order.toString());

			//elim_next = (String) i.next();
			Output.outmin(
				"Eliminating Variable "
					+ count_eliminations++
					+ " of "
					+ this._elimination_order.size()
					+ " : "
					+ elim_next.name);

			Vector tableset = this.get_relevant_factors(elim_next);
			FunctionVariableSet joint_fv_set =
				this.get_tableset_variables(tableset.iterator());

		/////////////////////
		//  number of mults
				int cpsize = joint_fv_set.cartesianProductSize();
				int num_vars = joint_fv_set.size();
				number_of_multiplications = number_of_multiplications + cpsize*num_vars;
		/////////////////////

			Output.outmin(
				"\nList of Variables Involved : " + joint_fv_set + "\n");
			//			

			Function add_back_in;
			Output.outrandtests(
				"Generate a factor of size: "
					+ joint_fv_set.cartesianProductSize());
			Output.outrandtests(
				"Domain Size of Variable to Eliminate: "
					+ elim_next.domain.size());

			if (elim_next.equals(v)) {
				add_back_in = factor_these(tableset, joint_fv_set);
				Output.outl("\n");
				Output.outl("Do not sum over " + v + ".");
			} else {

				add_back_in =
					sum_over(
						factor_these(tableset, joint_fv_set),
						joint_fv_set,
						new FunctionVariableSet(elim_next));
				Output.outl("\n");
				Output.outl("Sum over " + v + ".");
			}
			// Add it back in.
			Output.outrandtests(
				"Generated a factor of size: "
					+ add_back_in.variables.cartesianProductSize());

			Output.out("The new Factor: (newf):" + add_back_in);
			Output.outfactors(
				"The new Factor Normalized: (newf):"
					+ Compute.normalize(add_back_in));
			//factors.add((add_back_in));
			factors.add(Compute.normalize(add_back_in));

			//_bn.nodes.getFunctionVariableSet().	
			//		out("New factor set:" + factors);
		} // END : over elim order

		//now elim Q:
		Vector tableset = this.get_all_factors();
		////		Vector tableset = this.get_relevant_factors(v);
		FunctionVariableSet joint_fv_set =
			this.get_tableset_variables(tableset.iterator());
		Function add_back_in = factor_these(tableset, joint_fv_set);
		factors.add(Compute.normalize(add_back_in));

		//		factors.add(
		//				Compute.normalize(
		//					factor_these(
		//						this.get_relevant_factors(v),
		//						this.get_tableset_variables(get_relevant_factors(v).iterator())
		//						)
		//					)
		//				);

		long EndTime = java.util.Calendar.getInstance().getTimeInMillis();
		RunTime = EndTime - StartTime;
		Output.out_timer(RunTime);
		Output.out_query_infix(v.toString(), this._evidence.toString());
		Output.outfinal("Final Factors:" + factors);
		Output.outfinal(
			"----------------------------\n       End Query On\n----------------------------");
	}

	public Vector get_relevant_factors(FunctionVariable elim_next) {

		//get all the factors that have the variable elim_next.

		// Instantiate the fvs:
		FunctionVariableSet joint_fv_set =
			new FunctionVariableSet(new FunctionVariable("bogus"));
		Vector tableset = new Vector();

		// go through each factor (ie, Earthquake, Burglary ...)
		// and make a list of the ones with Earthquake (the elim. var.) in them.
		Output.outl("\n");

		Output.outmin("Number of Factors: " + factors.size());
		for (Iterator fi = this.factors.iterator(); fi.hasNext();) {

			// 
			Function next_f = (Function) fi.next();

			if (next_f
				.variables //.contains(new FunctionVariable(elim_next))) {
				.contains(elim_next)) {

				tableset.add(next_f);
				fi.remove();

				joint_fv_set = JoinFVSets(joint_fv_set, next_f.variables);
			}
			// We now have tableset as the facters to combine.

		}
		joint_fv_set = joint_fv_set.subtract(new FunctionVariable("bogus"));

		return tableset;

	}
	public Vector get_all_factors() {

		//get all the factors that have the variable elim_next.

		// Instantiate the fvs:
		Vector tableset = new Vector();

		// go through each factor (ie, Earthquake, Burglary ...)
		Output.outl("\n");
		Output.out_join_vars("Number of Factors: " + factors.size());

		for (Iterator fi = this.factors.iterator(); fi.hasNext();) {
			Function next_f = (Function) fi.next();

			tableset.add(next_f);
			fi.remove();
			// We now have tableset as the facters to combine.
		}

		return tableset;

	}
	public FunctionVariableSet get_tableset_variables(Iterator tsi) {

		if (tsi.hasNext()) {
			return this.JoinFVSets(
				((Function) tsi.next()).variables,
				this.get_tableset_variables(tsi));
		} else {
			return null;
		}

	}
	public void handle_the_evidence() {
		Output.outmin("handle the evidence");

		// Here we create an evidence function.
		// It includes all evidence variables.
		evidence_factor =
			Compute.makeEvidenceFunction(
				this._evidence.variables,
				this._evidence);

		Output.outline2();
		Output.out_evidence(
			"The Evidence Variables   :" + this._evidence.variables.toString());
		Output.out_evidence("The Evidence Assignments :" + this._evidence);
		Output.out_evidence(
			"The Evidence Factor      :" + this.evidence_factor);

		multiply_in_evidence();
	}

	public void multiply_in_evidence() {
		Output.outmin("Multily in evidence.");
		Function restricted_factor;
		Vector tableset = new Vector();

		//for each of the factors:
		for (Iterator fi = this.initial_factors.iterator(); fi.hasNext();) {
			Function next_f = (Function) fi.next();
			if (next_f
				.variables
				.containsAnyOf(this.evidence_factor.variables)) {

				//Reduce the evidence to just the common variables.
				FunctionVariableSet uncommon_evidence_variables =
					JoinFVSets(
						this.evidence_factor.variables,
						next_f.variables).subtract(
						next_f.variables);

				// Sum out the uncommon variables from the evidence.
				Function new_evidence_factor =
					sum_over(
						this.evidence_factor,
						this.evidence_factor.variables,
						uncommon_evidence_variables);

				// tableset should have the initial factor and the minimal evidence table
				tableset = new Vector();
				tableset.add(next_f);
				tableset.add(new_evidence_factor);

				//restricted_factor:
				// Factor on all the variables in the next factor and the new evidence.
				restricted_factor =
					factor_these(
						tableset,
						JoinFVSets(
							next_f.variables,
							new_evidence_factor.variables));

				// sum out the evidence variables:
				restricted_factor =
					sum_over(
						restricted_factor,
						restricted_factor.variables,
						new_evidence_factor.variables);

			} else {
				restricted_factor = next_f;
			}

			factors.add(restricted_factor);

		} // END : over elim order

		Output.outmi(
			"----------------------------\n       End Multiplying in Evidence.  \n----------------------------");
	}

	//	/////////////////////////////////////////////////////////////////////	
	//	/////////////////////////////////////////////////////////////////////	
	//	/////////////////////////////////////////////////////////////////////	

	public Function factor_these(Vector tableset, FunctionVariableSet fvs) {
		Output.outmin("factor_these");
		Output.outmin(
			"There are " + tableset.size() + " factors in the tableset.");
		//Function new_f = new Function();
		// for one assignment:
		double[] d = new double[fvs.cartesianProductSize()];
		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			d[dcount] = 1;
			Assignment a = (Assignment) fvsi.next();

			//out("Computed position: " + a.computePosition());
			for (Iterator ti = tableset.iterator(); ti.hasNext();) {
				Function tempf = (Function) ti.next();

				// This is where the factors are multiplied:
				//	out("Tableset:" + tableset);
				d[dcount] = d[dcount] * tempf.evaluate(a);
			}
			dcount++;

		}

		Function newf = new Function(fvs, d);
		//		out("the fvs: " + fvs);
		Output.outl("The new Factor: (newf):" + newf);
		Output.outl(
			"The new Factor Normalized: (newf):" + Compute.normalize(newf));
		//	return Compute.normalize(newf);
		return (newf);
	}

	public double[] make_prob(Function table, FunctionVariableSet fvs) {
		Output.outmin("factor_these");

		//Output.outmin(
		//	"There are " + tableset.size() + " factors in the tableset.");

		//Function new_f = new Function();
		// for one assignment:
		double[] d = new double[fvs.cartesianProductSize()];
		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			d[dcount] = 1;
			Assignment a = (Assignment) fvsi.next();

			//out("Computed position: " + a.computePosition());
			//for (Iterator ti = tableset.iterator(); ti.hasNext();) {
			//	Function tempf = (Function) ti.next();

			// This is where the factors are multiplied:
			//	out("Tableset:" + tableset);
			d[dcount] = d[dcount] * table.evaluate(a);
			//}
			dcount++;

		}

		Function newf = new Function(fvs, d);
		//		out("the fvs: " + fvs);
		Output.outl("The new Factor: (newf):" + newf);
		Output.outl(
			"The new Factor Normalized: (newf):" + Compute.normalize(newf));
		//	return Compute.normalize(newf);
		return (d);
	}

	public double[] make_prob(
		Function table,
		FunctionVariableSet fvs,
		Vector av) {
		//		Output.outmin("factor_these");

		//Output.outmin(
		//	"There are " + tableset.size() + " factors in the tableset.");

		//Function new_f = new Function();
		// for one assignment:
		double[] d = new double[av.size()];
		//		System.out.println("av.size() : " + av.size());
		int dcount = 0;

		for (Iterator avi = av.iterator(); avi.hasNext();) {

			//d[dcount] = 1;
			Assignment a = (Assignment) avi.next();

			//out("Computed position: " + a.computePosition());
			//for (Iterator ti = tableset.iterator(); ti.hasNext();) {
			//	Function tempf = (Function) ti.next();

			// This is where the factors are multiplied:
			//	out("Tableset:" + tableset);
			//			System.out.println("a = " + a);
			//			System.out.println("table.evaluate(a) = " + table.evaluate(a));

			d[dcount] = table.evaluate(a);
			//}
			dcount++;

		}

		//		System.out.println("fvs = " + fvs);
		//		System.out.println(d[0]);
		//		System.out.println(d[1]);

//		System.out.println("the fvs: " + fvs);
//		System.out.println("the fvs cpsize: " + fvs.cartesianProductSize());
		
		////////////////////////////////////////////////////////////////////////////
//							int pan_index = 0;
//							for (Iterator avi = av.iterator(); avi.hasNext();
//								pan_index++) {
//								Assignment pan = (Assignment) avi.next();
//								System.out.println(
//									"P("
//										+ fvs.toString()
//										+ "|"
//										+ pan.toString()
//										+ ") = "
//										+ d[pan_index]);
//							}
//							Output.outline2();
		/////////////////////////////////////////////////////////////////////
		
	//	inappropriate: // Function newf = new Function(fvs, d);
	
	//	System.out.println("The new Factor: (newf):" + newf);
	
		//		Output.outl(
		//			"The new Factor Normalized: (newf):" + Compute.normalize(newf));
		//	return Compute.normalize(newf);
		return (d);
	}

	public double[] make_prob(
		Function table,
		FunctionVariableSet fvs,
		Assignment assmt) {
		Output.outmin("factor_these");

		//Output.outmin(
		//	"There are " + tableset.size() + " factors in the tableset.");

		//Function new_f = new Function();
		// for one assignment:
		double[] d = new double[fvs.cartesianProductSize()];
		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			d[dcount] = 1;
			Assignment a = (Assignment) fvsi.next();

			//out("Computed position: " + a.computePosition());
			//for (Iterator ti = tableset.iterator(); ti.hasNext();) {
			//	Function tempf = (Function) ti.next();

			// This is where the factors are multiplied:
			//	out("Tableset:" + tableset);
			d[dcount] = d[dcount] * table.evaluate(a);
			//}
			dcount++;

		}

		Function newf = new Function(fvs, d);
		//		out("the fvs: " + fvs);
		Output.outl("The new Factor: (newf):" + newf);
		Output.outl(
			"The new Factor Normalized: (newf):" + Compute.normalize(newf));
		//	return Compute.normalize(newf);
		return (d);
	}

	public Function sum_over(
		Function f,
		FunctionVariableSet fvs,
		FunctionVariableSet s) {

		Output.outmin("sum_over");

		FunctionVariableSet fvs_less_s = fvs.subtract((s));

		// for one assignment:
		double[] d = new double[fvs_less_s.cartesianProductSize()];

		int dcount = 0;

		for (Iterator fvsi = fvs.assignmentIterator(); fvsi.hasNext();) {

			Assignment a = (Assignment) fvsi.next();

			d[a.computePosition(fvs_less_s)] =
				d[a.computePosition(fvs_less_s)] + f.evaluate(a);

		}
		Function newf = new Function(fvs_less_s, d);

		return newf;

	}

	public FunctionVariableSet JoinFVSets(
		FunctionVariableSet current_fvs,
		FunctionVariableSet fvs) {
		FunctionVariableSet return_fvs;

		if ((fvs == null) & (current_fvs == null)) {

			return_fvs = null;

		} else if (fvs == null) {

			return_fvs = current_fvs;

		} else if (current_fvs == null) {

			return_fvs = fvs;

		} else if (fvs.size() == 0) {

			return_fvs = current_fvs;

		} else if (current_fvs.size() == 0) {

			return_fvs = fvs;

		} else {

			Output.out_join_vars("Size of fvs : " + fvs.size());
			Output.out_join_vars("Size of fvs_current : " + current_fvs.size());
			Output.out_join_vars(current_fvs.toString());
			return_fvs = FunctionVariableSet.union(current_fvs, fvs);

		}

		return return_fvs;

	}

	public void Remove(String nodename) {

		//nodes.
		//		out(_bn.nodes.toString());
		//		BayesNetNode temp_bnn = _bn.nodes.getNode(v2e.name);
		//		Iterator i = _bn.nodes.getNodesWithTopologicalOrdering().iterator();
		//		i.next();
		//		i.remove();
		//		out(_bn.nodes.toString());

	}

	public Assignment SetupQuery(
		BayesNet bn,
		Vector variables,
		Vector values) {

		//		final Comparable[] vals = new Comparable[2];
		//		vals[0] = ComparableBoolean.TRUE;
		//		vals[1] = ComparableBoolean.TRUE;

		final FunctionVariable[] new_vars =
			new FunctionVariable[variables.size()];

		final Comparable[] new_vals = new Comparable[values.size()];

		List nodes = bn.nodes.getNodesWithTopologicalOrdering();

		Output.out_setup("Variables to setup: " + variables);

		Iterator val_i = values.iterator();
		Iterator var_i = variables.iterator();

		if (values.size() != variables.size()) {
			System.out.println(
				"Error: different number of values and variables!");
		}

		for (int var_index = 0; var_index < variables.size(); var_index++) {

			String next_var_name = (String) var_i.next();
			Comparable next_val = (Comparable) val_i.next();

			Output.out_setup("Variable : " + var_index + " : " + next_var_name);

			for (Iterator i = nodes.iterator(); i.hasNext();) {

				BayesNetNode bnn = (BayesNetNode) i.next();

				//							Output.out_setup("next_var_name : "+next_var_name);

				if (bnn.var.name.compareTo(next_var_name) == 0) {
					new_vars[var_index] =
						new FunctionVariable(next_var_name, bnn.var.domain);
					new_vals[var_index] = (next_val);
					//	new_vals[var_index] = (bnn.var.domain.getNextValue()next_val);
				}

			}

			//		final FunctionVariableSet fv_new_vars =

		}
		final Assignment new_evidence =
			new Assignment(new FunctionVariableSet(new_vars), new_vals);

		return new_evidence;

	}

	public Assignment makeNewAssignment(
		BayesNet bn,
		Vector variables,
		Vector values) {

		//		final Comparable[] vals = new Comparable[2];
		//		vals[0] = ComparableBoolean.TRUE;
		//		vals[1] = ComparableBoolean.TRUE;

		final FunctionVariable[] new_vars =
			new FunctionVariable[variables.size()];

		final Comparable[] new_vals = new Comparable[values.size()];

		List nodes = bn.nodes.getNodesWithTopologicalOrdering();

		Output.out_setup("Variables to setup: " + variables);

		Iterator val_i = values.iterator();
		Iterator var_i = variables.iterator();

		if (values.size() != variables.size()) {
			System.out.println(
				"Error: different number of values and variables!");
		}

		for (int var_index = 0; var_index < variables.size(); var_index++) {

			String next_var_name = (String) var_i.next();
			Comparable next_val = (Comparable) val_i.next();

			Output.out_setup("Variable : " + var_index + " : " + next_var_name);

			for (Iterator i = nodes.iterator(); i.hasNext();) {

				BayesNetNode bnn = (BayesNetNode) i.next();

				//							Output.out_setup("next_var_name : "+next_var_name);

				if (bnn.var.name.compareTo(next_var_name) == 0) {
					new_vars[var_index] =
						new FunctionVariable(next_var_name, bnn.var.domain);
					new_vals[var_index] = (next_val);
					//	new_vals[var_index] = (bnn.var.domain.getNextValue()next_val);
				}

			}

			//		final FunctionVariableSet fv_new_vars =

		}
		final Assignment new_assignment =
			new Assignment(new FunctionVariableSet(new_vars), new_vals);

		return new_assignment;

	}

	public Vector makePossibleAssignments(Function f) {
		Output.outlh1("Make Pos Assnts");

		//		final Comparable[] vals = new Comparable[2];
		//		vals[0] = ComparableBoolean.TRUE;
		//		vals[1] = ComparableBoolean.TRUE;

		//		final FunctionVariable[] new_vars =
		//			new FunctionVariable[f.variables.size()];
		//		final Comparable[] new_vals = new Comparable[f.variables.size()];
		Output.outlh1(f.variables);
		Output.outlh1(f.variables.getVariable(0));
		Output.outlh1(f.variables.getVariable(0).domain.toString());

		//fvicc = f.variables.assignmentIterator();
		Domain dm = f.variables.getVariable(0).domain;

		Vector assignment_vector = new Vector();
		int domain_count = 0;

		//		
		//		for (Iterator fi = dm.iterator();
		//			fi.hasNext();
		//			)	

		for (Iterator fi = f.variables.assignmentIterator(); fi.hasNext();) {

			//				final FunctionVariable[] new_vars =
			//					new FunctionVariable[f.variables.size()];
			//				final Comparable[] new_vals = new Comparable[f.variables.size()];
			//
			//			Comparable next_val = (Comparable) fi.next();
			//			
			//			System.out.println((next_val));
			//
			//			new_vars[domain_count] =
			//				new FunctionVariable(
			//					f.variables.getVariable(0).name,
			//					f.variables.getVariable(0).domain);
			//			new_vals[domain_count] = (next_val);
			//
			//			final Assignment new_assignment =
			//				new Assignment(new FunctionVariableSet(new_vars), new_vals);

			assignment_vector.add(fi.next());

		}

		//		final FunctionVariableSet fv_new_vars =

		Output.outlh1("End Make Pos Assnts");

		return assignment_vector;

	}

	public FunctionVariable MakeFunctionVariable(String sv) {

		List nodes = _bn.nodes.getNodesWithTopologicalOrdering();

		FunctionVariable new_var = new FunctionVariable(sv);

		for (Iterator i = nodes.iterator(); i.hasNext();) {
			BayesNetNode bnn = (BayesNetNode) i.next();

			if (bnn.var.name.compareTo(sv) == 0) {
				new_var = bnn.var;
			}
		}
		return new_var;
	}

	public Function query(BayesNetNode variable) {
		//return enumerationAsk(variable);
		return variable.cpt;
		//		return bn.nodes.getNode(1);
	}
	public Vector GenerateEliminationOrder() {
		Output.outmin("GenerateEliminationOrder");
		Vector elimination_order = new Vector();
		//	this._bn.nodes.getNodesWithTopologicalOrdering();

		List nodes_copy = nodes;
		while (nodes_copy.size() > 0) { // for each node

			int get_node_index = Random.random(nodes_copy.size());
			BayesNetNode bnn = (BayesNetNode) nodes.get(get_node_index);
			nodes_copy.remove(get_node_index);

			if (!this.evidence_factor.variables.contains(bnn.var)) {
				//Don't include E.
				if (!this.factor_on_v.equals(bnn.var)) { //Don't include Q.
					elimination_order.add(bnn.var);
				}
			}
		}

		//elimination_order.remove(this.factor_on_v);
		//	elimination_order.add(this.factor_on_v);
		//	elimination_order.insertElementAt(this.factor_on_v, 0);

		//	for(Iterator vfvi = this._evidence)
		elimination_order.remove(this.evidence_factor.variables);
		this._elimination_order = elimination_order;
		Output.outmin("Elim Order=" + elimination_order.toString());

		if (!this.GreedyFlag) {

			System.out.println(
				"Initial Elim Order=" + elimination_order.toString());
		}

		return elimination_order;
	}
	public Vector GenerateTopoEliminationOrder() {
		Output.outmin("GenerateEliminationOrder");
		Vector elimination_order = new Vector();
		//	this._bn.nodes.getNodesWithTopologicalOrdering();

		List nodes_copy = nodes;
		while (nodes_copy.size() > 0) { // for each node

			int get_node_index = Random.random(nodes_copy.size());
			BayesNetNode bnn = (BayesNetNode) nodes.get(get_node_index);
			nodes_copy.remove(get_node_index);

			if (!this.evidence_factor.variables.contains(bnn.var)) {
				//Don't include E.
				if (!this.factor_on_v.equals(bnn.var)) { //Don't include Q.
					elimination_order.add(bnn.var);
				}
			}
		}

		//elimination_order.remove(this.factor_on_v);
		//	elimination_order.add(this.factor_on_v);
		//	elimination_order.insertElementAt(this.factor_on_v, 0);

		//	for(Iterator vfvi = this._evidence)
		elimination_order.remove(this.evidence_factor.variables);
		this._elimination_order = elimination_order;
		Output.outmin("Elim Order=" + elimination_order.toString());

		if (!this.GreedyFlag) {

			System.out.println(
				"Initial Elim Order=" + elimination_order.toString());
		}

		return elimination_order;
	}

	public void getTable(String variable_name){
		
		System.out.println("Variable : " +	MakeFunctionVariable(variable_name).name.toString() );
		System.out.println("Table    : " +	_bn.nodes.getNode(variable_name).cpt.toString() );
 

	}

	public static void main(String[] args) {

		Queries q1 = new Queries();

		//		//////////////////////////////////////////////
		//		////              Task 1              ////////
		//		//////////////////////////////////////////////
		/*		
				q1.clear_file("Task1a.out", "");
				q1.task1a();
				q1.clear_file("Task1b.out", "");
				q1.task1b();
				q1.clear_file("Task1cInsurance1Greedy.out", "");
				q1.Task1cInsurance1Greedy();
		*/

		//		//////////////////////////////////////////////
		//		////              Task 2              ////////
		//		//////////////////////////////////////////////
				
//				q1.clear_file("Task2aInsurance1Greedy.result", "");
//				q1.clear_file("Task2aInsurance2Greedy.result", "");
//				q1.clear_file("Task2bCarpo1Greedy.result", "");
//				q1.clear_file("Task2bCarpo2Greedy.result", "");
//		
//				q1.Task2aInsurance1Greedy();
//				q1.Task2aInsurance2Greedy();
//				q1.Task2bCarpo1Greedy();
//				q1.Task2bCarpo2Greedy();
//	

		//		//////////////////////////////////////////////
		//		////          END of Task 1           ////////
		//		//////////////////////////////////////////////

		//		q1.Task2bCarpo1MarginalGreedy();

		//		//////////////////////////////////////////////
		//		////              Task 4              ////////
		//		//////////////////////////////////////////////
//				q1.clear_file("Task2aInsurance1Greedy.out", "");
//				q1.clear_file("Task2aInsurance2Greedy.out", "");
//				q1.clear_file("Task2bCarpo1Greedy.out", "");
//				q1.clear_file("Task2bCarpo2Greedy.out", "");
//		
//				q1.clear_file("Task2aInsurance1Greedy.mults", "");
//				q1.clear_file("Task2aInsurance2Greedy.mults", "");
//				q1.clear_file("Task2bCarpo1Greedy.mults", "");
//				q1.clear_file("Task2bCarpo2Greedy.mults", "");
//		
//				for (int test_count = 0; test_count < 50; test_count++) {
//		
//					q1.Task2aInsurance1Greedy();
//					q1.Task2aInsurance2Greedy();
//					q1.Task2bCarpo1Greedy();
//					q1.Task2bCarpo2Greedy();
//		
//				}
		
		//		//////////////////////////////////////////////
		//		////           End of Task 4          ////////
		//		//////////////////////////////////////////////

		////////////////////////////////////////////////
		////////////////////////////////////////////////
		//////              Task 3              ////////
		////////////////////////////////////////////////
		///////////////////////////////////////////////
		
		
//				q1.clear_file("Task2aInsurance1Random.out", "");
//				q1.clear_file("Task2aInsurance2Random.out", "");
//				q1.clear_file("Task2bCarpo1Random.out", "");
//				q1.clear_file("Task2bCarpo2Random.out", "");
//	
//				for (int test_count = 0; test_count < 50; test_count++) {
//		
//					try {
//						q1.Task2aInsurance1Random();
//						q1.Task2aInsurance2Random();
//						q1.Task2bCarpo1Random();
//						q1.Task2bCarpo2Random();
//					} catch (Error e) {				
//						e.printStackTrace();
//					}
//				}
//				
				
		//////////////////////////////////////////////
		////      END of Task 3              ////////
		//////////////////////////////////////////////

		//		//////////////////////////////////////////////
		//		////              Task 5              ////////
		//		//////////////////////////////////////////////

		//	q1.task5_likelihood();



// run time vs quality
//for (int i = 1000;i<10001;i=i+1000){
//
//		q1.task6_Insurance1_gibbs(4*i,i);
//	}

//test burnin
//	for (int i = 100;i<10001;i=i+100){
//
			
			int i=0;
			q1.task6_Insurance1_gibbs(35000,i);
//		}

		//for (int y = 1;y<100;y++){
		//	System.out.print(Random.random(10));
		//	System.out.print(", ");	
		//	}

		//	System.out.println(true);
		//	System.out.println(false);
		
		
		
//		q1.Task2bCarpo1MarginalGreedy(); 
	}
}
