/*
 * Created on Oct 18, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import edu.mit.six825.bn.bayesnet.*;
import edu.mit.six825.bn.functiontable.*;

// Contains the networks
//		Burglary
//		Insurance
//		Carpo
import edu.mit.six825.bn.inputs.*;

/**
 * @author larrybus
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Insurance_Driver {

	public static void main(String[] args) {

		BayesNet BurglaryInstance = Nets.getBurglary();
		System.out.println(
			"Alphabetical Ordering: " + BurglaryInstance.nodes.toString());
		System.out.println(
			"Topological Ordering: "
				+ BurglaryInstance
					.nodes
					.getNodesWithTopologicalOrdering()
					.toString());

		Solver b = new EnumerationSolver(BurglaryInstance);

		final FunctionVariable[] vars = new FunctionVariable[2];
		vars[0] = new FunctionVariable("JohnCalls");
		vars[1] = new FunctionVariable("MaryCalls");
		final Comparable[] vals = new Comparable[2];
		vals[0] = ComparableBoolean.TRUE;
		vals[1] = ComparableBoolean.TRUE;
		final Assignment evidence =
			new Assignment(new FunctionVariableSet(vars), vals);
		b.setEvidence(evidence);

		Function PofX = b.query(BurglaryInstance.nodes.getNode("Burglary"));
		System.out.println(PofX + "\n\n");
//		PofX = b.query(BurglaryInstance.nodes.getNode("Earthquake"));
//		System.out.println(PofX + "\n\n");
//		PofX = b.query(BurglaryInstance.nodes.getNode("Alarm"));
//		System.out.println(PofX + "\n\n");
//		PofX = b.query(BurglaryInstance.nodes.getNode("JohnCalls"));
//		System.out.println(PofX + "\n\n");
//		PofX = b.query(BurglaryInstance.nodes.getNode("MaryCalls"));
//		System.out.println(PofX + "\n\n");

		BayesNet BurglaryInstance2 = Nets.getBurglary();
		System.out.println(
			"Alphabetical Ordering: " + BurglaryInstance2.nodes.toString());
		System.out.println(
			"Topological Ordering: "
				+ BurglaryInstance2
					.nodes
					.getNodesWithTopologicalOrdering()
					.toString());

		Solver b2 = new EnumerationSolver(BurglaryInstance2);

		final FunctionVariable[] vars2 = new FunctionVariable[2];
		vars2[0] = new FunctionVariable("Burglary");
		vars2[1] = new FunctionVariable("JohnCalls");
		final Comparable[] vals2 = new Comparable[2];
		vals2[0] = ComparableBoolean.TRUE;
		vals2[1] = ComparableBoolean.TRUE;
		final Assignment evidence2 =
			new Assignment(new FunctionVariableSet(vars2), vals2);
		b2.setEvidence(evidence2);
		Function PofX2 = b2.query(BurglaryInstance2.nodes.getNode("Earthquake"));
		System.out.println(PofX2 + "\n\n");
		
		BayesNetNode bb = BurglaryInstance2.nodes.getNode("JohnCalls");
		System.out.println("bb = "+bb);
		System.out.println("bb.parents = "+bb.parents);
		System.out.println("bb.cpt = "+bb.cpt);
		System.out.println("bb.cpt.sum() = "+bb.cpt.sum());
		System.out.println("bb.cpt.variables = "+bb.cpt.variables);
		System.out.println("bb.cpt.variables = "+bb.cpt.variables);
		System.out.println("bb.var = "+bb.var);
		System.out.println("bb = "+bb);
		
		
		////////////////////////////////////////////////////
		
		BayesNet BurglaryInstance3 = Nets.getBurglary();
		
		Solver b3 = new EnumerationSolver(BurglaryInstance3);

				final FunctionVariable[] vars3 = new FunctionVariable[0];
				//vars2[0] = new FunctionVariable("Burglary");
				//vars2[1] = new FunctionVariable("JohnCalls");
				final Comparable[] vals3 = new Comparable[0];
//				vals2[0] = ComparableBoolean.TRUE;
//				vals2[1] = ComparableBoolean.TRUE;
				final Assignment evidence3 =
				new Assignment(new FunctionVariableSet(vars3), vals3);
				b3.setEvidence(evidence3);
				Function PofX3 = b3.query(BurglaryInstance3.nodes.getNode("Alarm"));
				System.out.println(PofX3 + "\n\n");
		
		System.out.println(PofX + "");
		System.out.println(PofX2 + "");
		System.out.println(PofX3 + "");
		System.out.println("Insurance Driver");
		
	}
}
