package ps2;

import java.util.HashMap;
import techniques.BN.*;

public class Evidence {

    protected static HashMap evidences;

    static {
	evidences = new HashMap();

	BayesNet burg = techniques.BN.Nets.getBurglary();
	BayesNet ins = techniques.BN.Nets.getInsurance();
	BayesNet carpo = techniques.BN.Nets.getCarpo();

	// 1.1
	HashMap e1_1 = new HashMap();
	e1_1.put(burg.getNode("JohnCalls"), Boolean.TRUE);
	e1_1.put(burg.getNode("MaryCalls"), Boolean.TRUE);
	evidences.put("1.1", e1_1);

	// 1.2
	HashMap e1_2 = new HashMap();
	e1_2.put(ins.getNode("Age"), "Adolescent");
	e1_2.put(ins.getNode("Antilock"), "False");
	e1_2.put(ins.getNode("Mileage"), "FiftyThou");
	evidences.put("1.2", e1_2);
	
	// 2.a.1
	HashMap e2a_1 = new HashMap();
	e2a_1.put(ins.getNode("Age"), "Adolescent");
	e2a_1.put(ins.getNode("Antilock"), "False");
	e2a_1.put(ins.getNode("Mileage"), "FiftyThou");
	e2a_1.put(ins.getNode("MakeModel"), "SportsCar");
	evidences.put("2.a.1", e2a_1);

	// 2.a.2
	HashMap e2a_2 = new HashMap();
	e2a_2.put(ins.getNode("Age"), "Adolescent");
	e2a_2.put(ins.getNode("Antilock"), "False");
	e2a_2.put(ins.getNode("Mileage"), "FiftyThou");
	e2a_2.put(ins.getNode("GoodStudent"), "True");
	evidences.put("2.a.2", e2a_2);

	// 2.b.1
	HashMap e2b_1 = new HashMap();
	e2b_1.put(carpo.getNode("N64"), "3");
	e2b_1.put(carpo.getNode("N113"), "1");
	e2b_1.put(carpo.getNode("N116"), "0");
	evidences.put("2.b.1", e2b_1);

	// 2.b.2
	HashMap e2b_2 = new HashMap();
	e2b_2.put(carpo.getNode("N146"), "1");
	e2b_2.put(carpo.getNode("N116"), "0");
	e2b_2.put(carpo.getNode("N121"), "1");
	evidences.put("2.b.2", e2b_2);

    }

    public static HashMap get(String key) {
	return (HashMap)evidences.get(key);
    }




}
