/*
 * Created on Oct 7, 2003
 *
 */
package techniques.BN.solver;

import java.util.HashMap;
import java.util.Map;
import java.util.Iterator;
import java.util.Date;

import techniques.BN.BayesNet;
import techniques.BN.Variable;

/**
 * Provides some helpful functionality, like maintaining the evidence variables
 * that are needed for implementing BayesNet solvers. 
 * 
 * @author vineet
 */
public abstract class Solver {
    protected BayesNet bn;
    protected HashMap evidence;
    protected long lastTime;

    /**
     * @param bn
     */
    public Solver(BayesNet _bn) {
	bn = _bn;
    }

    /**
     * @param e
     */
    public void setEvidenceGivenVal(HashMap e) {
	Iterator it = e.entrySet().iterator();
	HashMap e2 = new HashMap();
	while (it.hasNext()) {
	    Map.Entry iME = (Map.Entry) it.next();
	    Variable var = (Variable) iME.getKey();
	    int valNdx = var.getValNdx(iME.getValue());
	    e2.put(var, new Integer(valNdx));
	}
	setEvidence(e2);
    }
    public void setEvidence(HashMap e) {
	evidence = e;
    }
    public HashMap getEvidence() {
	return evidence;
    }

    /**
     * @param variable
     */
    abstract public double[] getProb(Variable variable);

    public double[] getTimedProb(Variable variable) {
	Date start = new Date();
	double[] probs = getProb(variable);
	Date end = new Date();
	this.lastTime = end.getTime() - start.getTime();
	return probs;
    }

    public long getLastTime() {
	return lastTime;
    }
}
